//
// File: AirportSocket.h
// Created by: Kristian Müller <Kristian-M@Kristian-M.de>
// Created on: Wed Oct  1 16:28:32 2003
//

#ifndef _AIRPORTSOCKET_H_
#define _AIRPORTSOCKET_H_

#include "IPv4Socket.h"
#include "GVar.h"
#include "StatusData.h"
	
#define AIRCTL_STS_CONNECTED	0x00
#define AIRCTL_STS_DISCONNECTED	0x01
#define AIRCTL_STS_CONNECTING	0x02
#define AIRCTL_STS_DISABLED	0x03

#define AIRCTL_VER_SILENT	0x00
#define AIRCTL_VER_SHORT	0x01
#define AIRCTL_VER_LONG		0x02
#define AIRCTL_VER_DEBUG	0x03
#define AIRCTL_VER_DEFAULT	AIRCTL_VER_LONG
		

class AirportSocket : public IPv4Socket{
	protected:
		bool bModemConnected;
		enum AirCtrlStsErrStat{success=0x00, failure=0x01};
		struct tOsuNmsElement {
			tOsuNmsElement(){
				sValue = NULL;
			}
			~tOsuNmsElement(){
				if (sValue != NULL){
//					delete[] sValue;   // I can't delete this because the interesting creation method??
				}
			}
			signed char *sValue;
			int iTag;
			int iLength;
		};
		struct tOsuNmsElement *osunms_element_get(struct tOsuNmsElement *aInElement, void *aInBuffer, int iInSize, int iInTag);
		long int convertOsuNms2Int(void *aInBuffer, int iInLenght);
//		StatusData *aLocalStatusData;
	public:
		AirportSocket(char *sHostname); // : IPv4Socket::IPv4Socket(sHostname,192);
		~AirportSocket();
		
		int connectModem();
		int disconnectModem();
		StatusData *getStatus(StatusData **aLocalStatusData);
};


#endif	//_AIRPORTSOCKET_H_
